﻿local oUF = bdCore.oUF
local raidwhitelist = {
	------------
	-- EN
	------------
	['Rot'] = true,
	['Spew Corruption'] = true,
	['Necrotic Venom'] = true,
	['Twisting Shadows'] = true,
	['Focused Gaze'] = true,
	['Nightmare Blades'] = true,
	
	------------
	-- ToV
	------------
	['Salty Spittle'] = true,
	['Fiery Phlegm'] = true,
	['Dark Discharge'] = true,
	
	-- Helya
	['Orb of Corruption'] = true,
	['Orb of Corrosion'] = true,
	['Taint of the Sea'] = true,
	

	------------
	-- NH
	------------
	['Arcanic Release'] = true,
	-- Skorpyron
	
	-- Trilliax
	
	-- CA
	
	-- Krosus
	['Orb of Destruction'] = true,
	
	-- Spellblade
	['Mark of Frost'] = true,
	['Searing Brand'] = true,
	
	-- Tichondrius
	['Carrion Plague'] = true,
	['Burning Soul'] = true,

	-- Botanist
	["Parasitic Fixate"] = true,
	["Parasitic Fetter"] = true,
	["Call of Night"] = true,
	
	-- Augur
	["Star Sign: Crab"] = true,
	["Star Sign: Wolf"] = true,
	["Star Sign: Dragon"] = true,
	["Star Sign: Hunter"] = true,
	["Fel Ejection"] = true,
	["Icy Ejection"] = true,
	
	-- Elisande
	['Conflexive Burst'] = true,
	
	-- Guldan
	['Fel Bonds'] = true,
	['Empowered Fel Bonds'] = true,
	["Eye of Gul'dan"] = true,
	["Empowered Eye of Gul'dan"] = true,
	["Flames of Sargeras"] = true,
}

local function cvar_set() end
local function npcallback() end
local function enumerateNameplates()
	for _, frame in pairs(C_NamePlate.GetNamePlates()) do
		local unit = frame.namePlateUnitToken
		npcallback("",frame,unit)
	end
end
local defaults = {}

--------------
-- Positioning
--------------
defaults[#defaults+1] = {label = {
	type="text",
	value="Sizing & Display"
}}
defaults[#defaults+1] = {nameplatedistance={
	type="slider",
	value=50,
	min=10,
	max=100,
	step=2,
	label="Nameplates Draw Distance",
	callback=function() cvar_set() end
}}

defaults[#defaults+1] = {nameplatemotion = {
	type = "dropdown",
	value = 1,
	options = {1,0},
	label = "Stacking: 1 for stacked, 0 for overlapping",
	callback = function() cvar_set() end
}}

defaults[#defaults+1] = {showhptext = {
	type = "checkbox",
	value = true,
	label = "Show nameplate HP/%",
	callback = function() enumerateNameplates() end
}}
defaults[#defaults+1] = {showhptexttargetonly = {
	type = "checkbox",
	value = false,
	label = "Show nameplate HP/% on target only",
	callback = function() enumerateNameplates() end
}}

defaults[#defaults+1] = {executechange = {
	type = "checkbox",
	value = true,
	label = "Change color in execute",
	callback = function() enumerateNameplates() end
}}

defaults[#defaults+1] = {showfriendlybar = {
	type = "checkbox",
	value = true,
	label = "Show health bar when targeting friendly.",
	callback = function() enumerateNameplates() end
}}

defaults[#defaults+1] = {width={
	type="slider",
	value=180,
	min=30,
	max=250,
	step=2,
	label="Nameplates Width",
	callback=function() enumerateNameplates() end
}}
defaults[#defaults+1] = {height={
	type="slider",
	value=14,
	min=4,
	max=30,
	step=1,
	label="Nameplates Height",
	callback=function() enumerateNameplates() end
}}

defaults[#defaults+1] = {enemynamesize={
	type="slider",
	value=14,
	min=8,
	max=20,
	step=1,
	label="Enemy Name Font Size",
	callback=function() enumerateNameplates() end
}}
defaults[#defaults+1] = {friendlynamesize={
	type="slider",
	value=16,
	min=8,
	max=22,
	step=1,
	label="Friendly Name Font Size",
	callback=function() enumerateNameplates() end
}}

-------------
-- Raid & Debuffs
-------------
defaults[#defaults+1] = {label = {
	type="text",
	value="Raid Settings"
}}
defaults[#defaults+1] = {raidmarkersize={
	type="slider",
	value=24,
	min=10,
	max=50,
	step=2,
	label="Raid Marker Icon Size",
	callback=function() enumerateNameplates() end
}}
defaults[#defaults+1] = {markposition = {
	type = "dropdown",
	value = "TOP",
	options = {"LEFT","TOP","RIGHT"},
	label = "Raid Marker position",
	tooltip = "Where raid markers should be positioned on the nameplate.",
	callback = function() enumerateNameplates() end
}}
defaults[#defaults+1] = {debuffsize={
	type="slider",
	value=40,
	min=20,
	max=40,
	step=2,
	label="Debuff Size",
}}
defaults[#defaults+1] = {raidbefuffs={
	type="slider",
	value=50,
	min=20,
	max=100,
	step=2,
	label="Raid Debuff Size",
}}

-------------
-- Auras
-------------
defaults[#defaults+1] = {label = {
	type="text",
	value="Auras"
}}
defaults[#defaults+1] = {selfwhitelist={
	type="list",
	value={},
	label="Enemy Debuffs (cast by you)",
	tooltip="Use to show a specified aura cast by you."
}}
defaults[#defaults+1] = {whitelist={
	type="list",
	value={},
	label="Friendly/Enemy Auras (cast by anyone)",
	tooltip="Use to show a specified aura cast by anyone."
}}
defaults[#defaults+1] = {blacklist={
	type="list",
	value={},
	label="Aura Blacklist",
	tooltip="Useful if you want to blacklist any auras that Blizzard tracks by default."
}}


local config = bdCore:addModule("Nameplates", defaults)
local scale = UIParent:GetEffectiveScale()*1
C_NamePlate.SetNamePlateFriendlySize(config.width * scale + 10,0.1)
C_NamePlate.SetNamePlateEnemySize(config.width * scale + 10, config.height * scale + 16)
SetCVar('nameplateShowSelf', 1)
SetCVar('nameplateOverlapV', 2.5)
SetCVar('nameplateOverlapH', 1)
SetCVar('nameplateMotionSpeed', .1)

local function cvar_set()
	local cvars = {
		['nameplateShowAll'] = 1,
		['nameplateMinAlpha'] = 0.7,
		['nameplateMaxAlpha'] = 1,
		['nameplateMaxAlphaDistance'] = 0,
		['nameplateMaxDistance'] = config.nameplatedistance+6, -- for some reason there is a 6 yd diff
		--['nameplateShowFriends'] = config.showfriends,
		--['nameplatePersonalShowAlways'] = 1,
		--['nameplateShowSelf'] = 1,
		--["nameplateMotionSpeed"] = config.speed, --0.1
		--["nameplateOverlapV"] = config.spacingV, --0.8
		--["nameplateOverlapH"] = config.spacingH, --0.8
		['nameplateMotion'] = tonumber(config.nameplatemotion),
		['nameplateMinScale'] = 1, 
		['nameplateLargerScale'] = 1, -- for bosses
		['nameplateOtherTopInset'] = 0.08, -- Default 0.08
		['nameplateOtherBottomInset'] = 0.1, -- Default 0.1
	}
	
	for k, v in pairs(cvars) do
		local current = tonumber(GetCVar(k))
		if (current ~= tonumber(v)) then
			SetCVar(k, v)
		end
	end
end

local function numberize(v)
	if v <= 9999 then return v end
	if v >= 1000000000 then
		local value = string.format("%.1fb", v/1000000000)
		return value
	elseif v >= 1000000 then
		local value = string.format("%.1fm", v/1000000)
		return value
	elseif v >= 10000 then
		local value = string.format("%.1fk", v/1000)
		return value
	end
end

local addon = CreateFrame("frame")
addon:RegisterEvent("CVAR_UPDATE")
addon:RegisterEvent("PLAYER_ENTERING_WORLD")
addon:SetScript("OnEvent",cvar_set)

local executerange = 20
local talentdetect = CreateFrame("frame")
talentdetect:RegisterEvent('PLAYER_ENTERING_WORLD')
talentdetect:RegisterEvent('ACTIVE_TALENT_GROUP_CHANGED')
talentdetect:RegisterEvent('PLAYER_TALENT_UPDATE')
talentdetect:RegisterEvent('ACTIVE_TALENT_GROUP_CHANGED')
talentdetect:SetScript("OnEvent",function()
	local class = select(2, UnitClass("player"))
	if (class == "PRIEST") then
		local RoS = select(4, GetTalentInfo(4, 2, 3))
		if (RoS) then
			executerange = 35
		else
			executerange = 20
		end
	end
end)

local function getcolor(unit)
	local reaction = UnitReaction(unit, "player") or 5
	
	if UnitIsPlayer(unit) then
		local class = select(2, UnitClass(unit))
		local color = RAID_CLASS_COLORS[class]
		return color.r, color.g, color.b
	elseif UnitCanAttack("player", unit) then
		if UnitIsDead(unit) then
			return 136/255, 136/255, 136/255
		else
			if reaction<4 then
				return 1, 68/255, 68/255
			elseif reaction==4 then
				return 1, 1, 68/255
			end
		end
	else
		if reaction<4 then
			return 48/255, 113/255, 191/255
		else
			return 1, 1, 1
		end
	end
end

local colors = {}
colors.tapped = {.6,.6,.6}
colors.offline = {.6,.6,.6}
colors.reaction = {}
colors.class = {}

for eclass, color in next, RAID_CLASS_COLORS do
	if not colors.class[eclass] then
		colors.class[eclass] = {color.r, color.g, color.b}
	end
end
for eclass, color in next, FACTION_BAR_COLORS do
	if not colors.reaction[eclass] then
		colors.reaction[eclass] = {color.r, color.g, color.b}
	end
end

local function round(num, numDecimalPlaces)
  return string.format("%." .. (numDecimalPlaces or 0) .. "f", num)
end


local function unitColor(unit)
	if (not UnitExists(unit)) then
		return unpack(colors.tapped)
	end
	if UnitIsPlayer(unit) then
		return unpack(colors.class[select(2, UnitClass(unit))])
	elseif UnitIsTapDenied(unit) then
		return unpack(colors.tapped)
	else
		return unpack(colors.reaction[UnitReaction(unit, 'player')])
	end
end

local function enemyStlye(self,unit)
	local nameplate = C_NamePlate.GetNamePlateForUnit(unit)
	local self = nameplate.ouf

	
	self.Auras:Hide()
	self.Debuffs:Show()
	if (UnitIsUnit(unit,"target")) then
		self:SetAlpha(1)
		
	else
		self:SetAlpha(0.5)
	end
	
	self.Name:SetTextColor(1,1,1)
	self.Name:ClearAllPoints()
	self.Name:SetFont(bdCore.media.font, config.enemynamesize)
	self.Name:SetShadowColor(0,0,0)
	self.Name:SetPoint("BOTTOM", self, "TOP", 0, 6)	
	self.Castbar:SetAlpha(1)
	self.Health:Show()
	--self.Power:Hide()
end

local function npcStyle(self,unit)
	local nameplate = C_NamePlate.GetNamePlateForUnit(unit)
	local self = nameplate.ouf
	
	if (UnitIsUnit(unit,"target")) then
		self:SetAlpha(1)
	else
		self:SetAlpha(0.7)
	end
	
	self.background:Hide()
	self.Auras:Hide()
	self.Health:Hide()
	--self.Power:Hide()
	self.Name:SetTextColor(unitColor(unit))
	self.Name:ClearAllPoints()
	self.Name:SetPoint("TOP", self, "TOP", 0, 10)	
	self.Castbar:SetAlpha(0)
end
local function playerStyle(self,unit)
	local nameplate = C_NamePlate.GetNamePlateForUnit(unit)
	local self = nameplate.ouf
	
	self.Auras:Show()
	self.Auras:ClearAllPoints()
	self.Auras:SetPoint("BOTTOM", self.Name, "TOP", -2, 10)
	--self.Power:Hide()
	self.Health:Hide()
	self.background:Hide()
	self.Castbar:SetAlpha(0)
	self.Name:Show()
	self.Name:ClearAllPoints()
	self.Name:SetFont(bdCore.media.font, config.friendlynamesize, "OUTLINE")
	self.Name:SetShadowColor(0,0,0,0)
	self.Name:SetTextColor(unitColor(unit))
	
	
	nameplate:SetScript("OnUpdate",function()	
		local selfpoint, object, objectpoint, x, y = nameplate:GetPoint()
		self.Name:SetPoint("CENTER", WorldFrame, "CENTER", 0, (30-((y-350)/4))*scale)
	end)
end

-- Style your friends
local function friendlyStyle(self, unit)
	local nameplate = C_NamePlate.GetNamePlateForUnit(unit)
	local self = nameplate.ouf
	
	--self.Power:Hide()
	self.Debuffs:Hide()
	self.Auras:Show()
	self.Health:Hide()
	if (UnitIsUnit(unit,"target")) then
		self:SetAlpha(1)
		if (config.showfriendlybar) then
			self.Health:Show()
		end
		self.Name:ClearAllPoints()
		self.Name:SetPoint("TOP", self, "TOP", 0, 20)	
	else
		self:SetAlpha(0.8)
		self.Health:Hide()
		self.Name:ClearAllPoints()
		self.Name:SetPoint("TOP", self, "TOP", 0, 6)
	end
	
	if (UnitIsUnit(unit,"pet")) then
		self.Health:Show()
	end
	
	self.background:Hide()
	self.Name:SetTextColor(unitColor(unit))
	self.Name:SetFont(bdCore.media.font, config.friendlynamesize, "OUTLINE")
	self.Name:SetShadowColor(0,0,0,0)
	
	self.Castbar:SetAlpha(0)
end

--[[
local function kickColor(self, unit, name, castid)
	local interruptable = select(9, UnitCastingInfo(unit)) == 1 or false
	if (interruptable == true) then
		self.Icon:SetDesaturated(false)
		self:SetStatusBarColor(.1, .4, .7, 1)
	elseif (interruptable == false) then
		self.Icon:SetDesaturated(1)
		self:SetStatusBarColor(.7, .7, .7, 1)
	else
		self:Hide()
	end
end--]]

local function threatColor(self, forced)
	if (UnitIsPlayer(self.unit)) then return end
	local healthbar = self.Health
	local combat = UnitAffectingCombat("player")
	local threat = select(2, UnitDetailedThreatSituation("player", self.unit));
	local targeted = select(1, UnitDetailedThreatSituation("player", self.unit));
	local reaction = UnitReaction("player", self.unit);
	local perc = (UnitHealth(self.unit) / UnitHealthMax(self.unit)) * 100

	if (UnitIsTapDenied(self.unit)) then
		healthbar:SetStatusBarColor(.5,.5,.5)
	elseif(combat) then 
		if(threat and threat >= 1) then
			if(threat == 3) then
				healthbar:SetStatusBarColor(.79, .3, .21, 1)
			elseif (threat == 2 or threat == 1 or targeted) then
				healthbar:SetStatusBarColor(1, .55, 0.3)
			end
		else
			healthbar:SetStatusBarColor(0.3, 1, 0.3)
			if (config.executechange and perc <= executerange) then
				healthbar:SetStatusBarColor(.1, .4, .7)
			end
		end
	elseif (not forced) then
		self.Health:ForceUpdate()
	end
end

--[[
	if (bdCore:filterAura(name,unitCaster,true) and config.bufftrackers) then
				if (unitCaster == "player" and duration ~= 0 and duration < 300) then
					return true 
				end
			end
]]

local function npcallback(event,nameplate,unit)
	local scale = UIParent:GetEffectiveScale()*1
	if (not InCombatLockdown()) then
		C_NamePlate.SetNamePlateFriendlySize(config.width * scale + 10,0.1)
		C_NamePlate.SetNamePlateEnemySize(config.width * scale + 10, config.height * scale + 16)
	end
	if (unit) then
		local unit = unit or "target"
		local nameplate = C_NamePlate.GetNamePlateForUnit(unit)
		local self = nameplate.ouf

		self:EnableMouse(false)
		self.Health:EnableMouse(false)
		local ufaction = select(1, UnitFactionGroup(unit))
		local pfaction = select(1, UnitFactionGroup("player"))
		if (not select(1, UnitCastingInfo(unit))) then
			self.Castbar:Hide()
		end
		
		if (config.showhptext) then
			self.Curhp:Show()
			if (config.showhptexttargetonly and not UnitIsUnit(unit,"target")) then
				self.Curhp:Hide()
			end
		else
			self.Curhp:Hide()
		end
		
		self.RaidIcon:SetSize(config.raidmarkersize, config.raidmarkersize)
		self.RaidIcon:ClearAllPoints()
		if (config.markposition == "LEFT") then
			self.RaidIcon:SetPoint('RIGHT', self, "LEFT", -(config.raidmarkersize/2), 0)
		elseif (config.markposition == "RIGHT") then
			self.RaidIcon:SetPoint('LEFT', self, "RIGHT", config.raidmarkersize/2, 0)
		else
			self.RaidIcon:SetPoint('BOTTOM', self, "TOP", 0, config.raidmarkersize)
		end
		
		--IsUnitOnQuest
		
		
		self:SetScript("OnUpdate",function() end)
		
		if (UnitIsUnit(unit,"player")) then
			playerStyle(self,unit)
		elseif (UnitIsPlayer(unit) and UnitIsFriend("player",unit)) then
			friendlyStyle(self, unit)
		elseif (not UnitIsPlayer(unit) and (UnitReaction("player",unit) and UnitReaction("player",unit) >= 5) or ufaction == pfaction or ufaction == "Neutral") then
			npcStyle(self, unit)
		else
			enemyStlye(self,unit)
		end
		
		--[[if (UnitIsUnit(unit,"player")) then
			self.Name:Hide()
			--self.Power:Show()
			self.Castbar:Hide()
		else
			self.Name:Show()
			--self.Power:Hide()
			self.Castbar:Show()		
		end--]]
	end
	
	cvar_set()
end

local function style(self,unit)
	local scale = UIParent:GetEffectiveScale()*1
	local nameplate = C_NamePlate.GetNamePlateForUnit(unit)
	local main = self
	nameplate.ouf = self
	
	self:EnableMouse(false)
	
	self.background = self:CreateTexture(nil, "BACKGROUND", nil, -7)
	self.background:SetTexture(bdCore.media.flat)
	self.background:SetAllPoints(self)
	self.background:SetVertexColor(0,1,0,.3)

	self.unit = unit
	self:SetScript("OnEnter", function()
		ShowUIPanel(GameTooltip)
		GameTooltip:SetOwner(self, "ANCHOR_NONE")
		GameTooltip:SetUnit(self.unit)
		GameTooltip:Show()
	end)
	self:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)
	self.hooked = true
	
	self:SetPoint("BOTTOMLEFT",nameplate,"BOTTOMLEFT", 2, 2)
	self:SetPoint("BOTTOMRIGHT",nameplate,"BOTTOMRIGHT", -2, 2)
	self:SetScale(scale)
	self:SetHeight(config.height)
	
	self.Name = self.Name or self:CreateFontString(nil)
	self.Name:SetFont(bdCore.media.font, 14)
	self.Name:SetShadowOffset(1,-1)
	self:Tag(self.Name, '[name]')

	oUF.Tags.Events['curhp'] = 'UNIT_HEALTH_FREQUENT UNIT_HEALTH UNIT_MAXHEALTH'
	oUF.Tags.Methods['curhp'] = function(unit)
		local hp, hpMax = UnitHealth(unit), UnitHealthMax(unit)
		local hpPercent = hp / hpMax
		if hpMax == 0 then return end
		return numberize(hp).." - "..round(hpPercent * 100,1);
	end

	self.Health = CreateFrame("StatusBar", nil, self)
	self.Health:SetStatusBarTexture(bdCore.media.smooth)
	self.Health:SetAllPoints(self)
	self.Health.frequentUpdates = true
	self.Health.colorTapping = true
	self.Health.colorDisconnected = true
	self.Health.colorClass = true
	self.Health.colorReaction = true
	self.Health.colorHealth = true
	bdCore:setBackdrop(self.Health,true)
	self.Health:EnableMouse(false)

	self.Curhp = self.Health:CreateFontString(nil,"OVERLAY")
	self.Curhp:SetFont(bdCore.media.font, 12,"OUTLINE")
	self.Curhp:SetJustifyH("RIGHT")
	self.Curhp:SetShadowColor(0,0,0,0)
	self.Curhp:SetAlpha(0.8)
	self.Curhp:SetPoint("RIGHT", self.Health, "RIGHT", -4, 0)
	self:Tag(self.Curhp, '[curhp]')

	
	self.Health:RegisterEvent("PLAYER_REGEN_DISABLED")
	self.Health:RegisterEvent("PLAYER_REGEN_ENABLED")
	self.Health:RegisterEvent("UNIT_THREAT_SITUATION_UPDATE")
	self.Health:RegisterEvent("UNIT_THREAT_LIST_UPDATE")
	self:RegisterEvent("PLAYER_TARGET_CHANGED",function()
		npcallback("","",main.unit,main)
	end)
	
	self.Health:SetScript("OnEvent",function()
		threatColor(main)
	end)
	function self.Health:PostUpdate()
		threatColor(main,true)
	end
	
	-- Absorb
	self.TotalAbsorb = CreateFrame('StatusBar', nil, self.Health)
	self.TotalAbsorb:SetAllPoints(self.Health)
	self.TotalAbsorb:SetStatusBarTexture(bdCore.media.flat)
	self.TotalAbsorb:SetStatusBarColor(.1,.1,.1,.6)
	
	-- Raid Icon
	self.RaidIcon = self:CreateTexture(nil, "OVERLAY",nil,7)
	self.RaidIcon:SetSize(config.raidmarkersize, config.raidmarkersize)
	if (config.markposition == "LEFT") then
		self.RaidIcon:SetPoint('LEFT', self, "RIGHT", -(config.raidmarkersize/2), 0)
	elseif (config.markposition == "RIGHT") then
		self.RaidIcon:SetPoint('RIGHT', self, "LEFT", config.raidmarkersize/2, 0)
	else
		self.RaidIcon:SetPoint('BOTTOM', self, "TOP", 0, config.raidmarkersize)
	end
	
	
	-- For friendlies
	self.Auras = CreateFrame("Frame", nil, self)
	self.Auras:SetPoint("BOTTOM", self, "TOP", -2, 18)
	self.Auras:SetSize((config.raidbefuffs*2)+4, config.raidbefuffs)
	self.Auras:EnableMouse(false)
	self.Auras.size = config.raidbefuffs
	self.Auras.initialAnchor  = "BOTTOM"
	self.Auras.spacing = 2
	self.Auras.num = 20
	self.Auras['growth-y'] = "UP"
	self.Auras['growth-x'] = "RIGHT"
	self.Auras.CustomFilter = function(icons, unit, name, rank, icon, count, dispelType, duration, expires, caster, isStealable, nameplateShowPersonal, spellID, canApplyAura, isBossDebuff, _, nameplateShowAll)
		local allow = false
		
		if (raidwhitelist[name]) then
			allow = true
		end
		if (config.whitelist and config.whitelist[name]) then
			allow = true
		end
		if (config.selfwhitelist and (config.selfwhitelist[name] and caster == "player")) then
			allow = true
		end
		if (config.blacklist and config.blacklist[name]) then
			allow = false
		end
		
		return allow
	end
	
	self.Auras.PostUpdateIcon = function(Auras, unit, button)
		local cdtext = button.cd:GetRegions()
		bdCore:setBackdrop(button)
		cdtext:SetFont(bdCore.media.font,14,"OUTLINE")
		cdtext:SetShadowColor(0,0,0,0)
		cdtext:SetJustifyH("CENTER")
		cdtext:ClearAllPoints()
		cdtext:SetAllPoints(button)
		
		button.count:SetFont(bdCore.media.font,12,"OUTLINE")
		button.count:SetShadowColor(0,0,0,0)
		button.count:SetJustifyH("RIGHT")
		button.count:ClearAllPoints()
		button.count:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", 2, -2)
		
		button:EnableMouse(false)
		button.icon:SetTexCoord(0.1, 0.9, 0.1, 0.9)
		button.cd:SetReverse(true)
	end
	
	
	-- For Enemies
	self.Debuffs = CreateFrame("Frame", nil, self)
	self.Debuffs:ClearAllPoints()
	self.Debuffs:SetPoint("BOTTOMLEFT", self, "TOPLEFT", 0, 24)
	self.Debuffs:SetSize(config.width, config.debuffsize)
	self.Debuffs:EnableMouse(false)
	self.Debuffs.size = config.debuffsize
	self.Debuffs.initialAnchor  = "BOTTOMLEFT"
	self.Debuffs.spacing = 2
	self.Debuffs.num = 20
	self.Debuffs['growth-y'] = "UP"
	self.Debuffs['growth-x'] = "RIGHT"
	self.Debuffs.CustomFilter = function(icons, unit, name, rank, icon, count, dispelType, duration, expires, caster, isStealable, nameplateShowPersonal, spellID, canApplyAura, isBossDebuff, _, nameplateShowAll)
		local allow = false
		
		if (bdCore:filterAura(name,caster,true)) then
			allow = true 
		end
		
		if (nameplateShowAll or (nameplateShowPersonal and caster == "player")) then
			allow = true
		end
		if (config.whitelist and config.whitelist[name]) then
			allow = true
		end
		if (config.selfwhitelist and (config.selfwhitelist[name] and caster == "player")) then
			allow = true
		end
		if (config.blacklist and config.blacklist[name]) then
			allow = false
		end
		
		return allow
	end
	
	
	self.Debuffs.PostUpdateIcon = function(self, unit, button, index)
		local cdtext = button.cd:GetRegions()
		bdCore:setBackdrop(button)
		cdtext:SetFont(bdCore.media.font,14,"OUTLINE")
		cdtext:SetShadowColor(0,0,0,0)
		cdtext:SetJustifyH("LEFT")
		cdtext:ClearAllPoints()
		cdtext:SetPoint("TOPLEFT",button,"TOPLEFT",-1,8)
		
		button.count:SetFont(bdCore.media.font,12,"OUTLINE")
		button.count:SetTextColor(1,.8,.3)
		button.count:SetShadowColor(0,0,0,0)
		button.count:SetJustifyH("RIGHT")
		button.count:ClearAllPoints()
		button.count:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", 2, -1)
		
		button:EnableMouse(false)
		button.icon:SetTexCoord(0.08, 0.9, 0.08, 0.9)
		button:SetHeight(config.debuffsize*.6)
		button.cd:SetReverse(true)
	end
	
	self.Castbar = CreateFrame("StatusBar", nil, self)
	self.Castbar:SetFrameLevel(3)
	self.Castbar:SetStatusBarTexture(bdCore.media.flat)
	self.Castbar:SetStatusBarColor(.1, .4, .7, 1)
	self.Castbar:SetPoint("TOPLEFT", self.Health, "BOTTOMLEFT", 0, -2)
	self.Castbar:SetPoint("BOTTOMRIGHT", self.Health, "BOTTOMRIGHT", 0, -12)
	bdCore:setBackdrop(self.Castbar)
	
	self.Castbar.Text = self.Castbar:CreateFontString(nil, "OVERLAY")
	self.Castbar.Text:SetFont(bdCore.media.font, 11, "OUTLINE")
	self.Castbar.Text:SetJustifyH("RIGHT")
	self.Castbar.Text:SetPoint("CENTER", self.Castbar, "CENTER")
	
	self.Castbar.Icon = self.Castbar:CreateTexture(nil, "OVERLAY")
	self.Castbar.Icon:SetTexCoord(0.08, 0.92, 0.08, 0.92)
	self.Castbar.Icon:SetDrawLayer('ARTWORK')
	self.Castbar.Icon:SetSize(config.height+12, config.height+12)
	self.Castbar.Icon:SetPoint("BOTTOMRIGHT",self.Castbar, "BOTTOMLEFT", -2, 0)
	
	self.Castbar.bg = self.Castbar:CreateTexture(nil, "BORDER")
	self.Castbar.bg:SetTexture(bdCore.media.flat)
	self.Castbar.bg:SetVertexColor(unpack(bdCore.media.border))
	self.Castbar.bg:SetPoint("TOPLEFT", self.Castbar.Icon, "TOPLEFT", -bdCore.config.General.border, bdCore.config.General.border)
	self.Castbar.bg:SetPoint("BOTTOMRIGHT", self.Castbar.Icon, "BOTTOMRIGHT", bdCore.config.General.border, -bdCore.config.General.border)
	
	local function ChannelColor(self, unit, ...)
		local interruptable = select(8, UnitCastingInfo(unit)) == false or false
		local name = select(1, UnitCastingInfo(unit))
		
		if (name == nil) then
			self:Hide()
		elseif (interruptable) then
			self.Icon:SetDesaturated(false)
			self:SetStatusBarColor(.1, .4, .7, 1)
		else
			self.Icon:SetDesaturated(1)
			self:SetStatusBarColor(.7, .7, .7, 1)
		end
	end
	local function CastColor(self, unit, ...)
		local interruptable = select(9, UnitCastingInfo(unit)) == false or false
		local name = select(1, UnitCastingInfo(unit))
		
		if (name == nil) then
			self:Hide()
		elseif (interruptable) then
			self.Icon:SetDesaturated(false)
			self:SetStatusBarColor(.1, .4, .7, 1)
		else
			self.Icon:SetDesaturated(1)
			self:SetStatusBarColor(.7, .7, .7, 1)
		end
	end
	
	self.Castbar.PostChannelStart = ChannelColor
	self.Castbar.PostChannelUpdate = ChannelColor
	self.Castbar.PostCastStart = CastColor
	self.Castbar.PostCastDelayed = CastColor
	self.Castbar.PostCastNotInterruptible = function(self, unit, ...)
		CastColor(self, unit)
		ChannelColor(self, unit)
	end
	self.Castbar.PostCastInterruptible = function(self, unit, ...)
		CastColor(self, unit)
		ChannelColor(self, unit)
	end
end

bdCore:hookEvent("nameplate_update",enumerateNameplates)

oUF:RegisterStyle("bdNameplates", style) --styleName: String, styleFunc: Function
oUF:SpawnNamePlates("bdNameplates", "bdNameplates", npcallback)